import { IService } from 'loopback4-billing';
import { PaymentSourceDto } from '../models/dto/payment-dto.model';
import { InvoiceRepository } from '../repositories';
import { BillingCustomerRepository } from '../repositories/billing-customer.repository';
export declare class BillingPaymentSourceController {
    billingCustomerRepository: BillingCustomerRepository;
    invoiceRepository: InvoiceRepository;
    private readonly billingProvider;
    constructor(billingCustomerRepository: BillingCustomerRepository, invoiceRepository: InvoiceRepository, billingProvider: IService);
    create(paymentSourceDto: PaymentSourceDto): Promise<PaymentSourceDto>;
    getPaymentSource(paymentSourceId: string): Promise<PaymentSourceDto>;
    deleteById(paymentSourceId: string): Promise<void>;
}
