import { Plan } from '../models';
import { Feature, FeatureRepository, FeatureValues, FeatureValuesRepository } from '@sourceloop/feature-toggle-service';
import { DataObject } from '@loopback/repository';
import { PlanRepository } from '../repositories';
export declare class PlanFeaturesController {
    planRepository: PlanRepository;
    featureValuesRepository: FeatureValuesRepository;
    featureRepository: FeatureRepository;
    constructor(planRepository: PlanRepository, featureValuesRepository: FeatureValuesRepository, featureRepository: FeatureRepository);
    getPlanFeatures(id: string): Promise<DataObject<Plan> & {
        features: DataObject<Feature & {
            values: FeatureValues[];
        }>[];
    }>;
    setPlanFeatures(id: string, featureValues: FeatureValues[]): Promise<FeatureValues[]>;
    updatePlanFeatures(id: string, featureValues: Partial<FeatureValues>[]): Promise<FeatureValues[]>;
}
