import { Count, Filter, FilterExcludingWhere, Where } from '@loopback/repository';
import { Resource } from '../models';
import { ResourceRepository } from '../repositories';
export declare class ResourceController {
    resourceRepository: ResourceRepository;
    constructor(resourceRepository: ResourceRepository);
    create(resource: Omit<Resource, 'id'>): Promise<Resource>;
    count(where?: Where<Resource>): Promise<Count>;
    find(filter?: Filter<Resource>): Promise<Resource[]>;
    updateAll(resource: Resource, where?: Where<Resource>): Promise<Count>;
    findById(id: string, filter?: FilterExcludingWhere<Resource>): Promise<Resource>;
    updateById(id: string, resource: Resource): Promise<void>;
    replaceById(id: string, resource: Resource): Promise<void>;
    deleteById(id: string): Promise<void>;
}
