"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubscriptionInvoiceController = void 0;
const tslib_1 = require("tslib");
const repository_1 = require("@loopback/repository");
const rest_1 = require("@loopback/rest");
const models_1 = require("../models");
const repositories_1 = require("../repositories");
let SubscriptionInvoiceController = class SubscriptionInvoiceController {
    constructor(subscriptionRepository) {
        this.subscriptionRepository = subscriptionRepository;
    }
    async getInvoice(id) {
        return this.subscriptionRepository.invoice(id);
    }
};
exports.SubscriptionInvoiceController = SubscriptionInvoiceController;
tslib_1.__decorate([
    (0, rest_1.get)('/subscriptions/{id}/invoice', {
        responses: {
            '200': {
                description: 'Invoice belonging to Subscription',
                content: {
                    'application/json': {
                        schema: (0, rest_1.getModelSchemaRef)(models_1.Invoice),
                    },
                },
            },
        },
    }),
    tslib_1.__param(0, rest_1.param.path.string('id')),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object]),
    tslib_1.__metadata("design:returntype", Promise)
], SubscriptionInvoiceController.prototype, "getInvoice", null);
exports.SubscriptionInvoiceController = SubscriptionInvoiceController = tslib_1.__decorate([
    tslib_1.__param(0, (0, repository_1.repository)(repositories_1.SubscriptionRepository)),
    tslib_1.__metadata("design:paramtypes", [repositories_1.SubscriptionRepository])
], SubscriptionInvoiceController);
//# sourceMappingURL=subscription-invoice.controller.js.map