import { BindingKey, Interceptor } from '@loopback/core';
import { ISubscriptionServiceConfig } from './types';
import { VerifyFunction } from 'loopback4-authentication';
import { AnyObject } from '@loopback/repository';
import { IAuthUser } from 'loopback4-authorization';
export declare namespace SubscriptionServiceBindings {
    const Config: BindingKey<ISubscriptionServiceConfig | null>;
}
export declare const WEBHOOK_VERIFIER: BindingKey<Interceptor>;
/**
 * Binding key for the lead token verifier.
 */
export declare const LEAD_TOKEN_VERIFIER: BindingKey<VerifyFunction.BearerFn<AnyObject>>;
/**
 * Binding key for the system user.
 */
export declare const SYSTEM_USER: BindingKey<IAuthUser & AnyObject>;
